/* SourceInterfaces.c generated by valac 0.22.1, the Vala compiler
 * generated from SourceInterfaces.vala, do not modify */

/* Copyright 2011-2013 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* See the note in MediaInterfaces.vala for some thoughts on the theory of expanding Shotwell's*/
/* features via interfaces rather than class heirarchies.*/
/* Indexable DataSources provide raw strings that may be searched against (and, in the future,*/
/* indexed) for free-text search queries.  DataSources implementing Indexable must prepare and*/
/* store (i.e. cache) these strings using prepare_indexable_string(s), as preparing the strings*/
/* for each call is expensive.*/
/**/
/* When the indexable string has changed, the object should fire an alteration of*/
/* "indexable:keywords".  The prepare methods will not do this.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};



GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
const gchar* indexable_get_indexable_keywords (Indexable* self);
gchar* indexable_prepare_indexable_string (const gchar* str);
gboolean is_string_empty (const gchar* s);
gchar* string_remove_diacritics (const gchar* istring);
gchar* indexable_prepare_indexable_strings (gchar** strs, int strs_length1);


const gchar* indexable_get_indexable_keywords (Indexable* self) {
#line 19 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	g_return_val_if_fail (IS_INDEXABLE (self), NULL);
#line 19 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	return INDEXABLE_GET_INTERFACE (self)->get_indexable_keywords (self);
#line 78 "SourceInterfaces.c"
}


gchar* indexable_prepare_indexable_string (const gchar* str) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 22 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp0_ = str;
#line 22 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp1_ = is_string_empty (_tmp0_);
#line 22 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	if (_tmp1_) {
#line 23 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		result = NULL;
#line 23 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		return result;
#line 101 "SourceInterfaces.c"
	}
#line 24 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp2_ = str;
#line 24 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) (-1));
#line 24 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp4_ = _tmp3_;
#line 24 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp5_ = string_remove_diacritics (_tmp4_);
#line 24 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp6_ = _tmp5_;
#line 24 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_g_free0 (_tmp4_);
#line 24 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	result = _tmp6_;
#line 24 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	return result;
#line 119 "SourceInterfaces.c"
}


gchar* indexable_prepare_indexable_strings (gchar** strs, int strs_length1) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gboolean _tmp3_ = FALSE;
	GString* builder = NULL;
	GString* _tmp4_ = NULL;
	gint ctr = 0;
	const gchar* _tmp23_ = NULL;
	GString* _tmp24_ = NULL;
	const gchar* _tmp25_ = NULL;
	gboolean _tmp26_ = FALSE;
	const gchar* _tmp29_ = NULL;
	gchar* _tmp30_ = NULL;
#line 28 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp1_ = strs;
#line 28 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp1__length1 = strs_length1;
#line 28 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	if (_tmp1_ == NULL) {
#line 28 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		_tmp0_ = TRUE;
#line 146 "SourceInterfaces.c"
	} else {
		gchar** _tmp2_ = NULL;
		gint _tmp2__length1 = 0;
#line 28 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		_tmp2_ = strs;
#line 28 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		_tmp2__length1 = strs_length1;
#line 28 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		_tmp0_ = _tmp2__length1 == 0;
#line 156 "SourceInterfaces.c"
	}
#line 28 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp3_ = _tmp0_;
#line 28 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	if (_tmp3_) {
#line 29 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		result = NULL;
#line 29 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		return result;
#line 166 "SourceInterfaces.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp4_ = g_string_new ("");
#line 31 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	builder = _tmp4_;
#line 32 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	ctr = 0;
#line 174 "SourceInterfaces.c"
	{
		gboolean _tmp5_ = FALSE;
#line 33 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		_tmp5_ = TRUE;
#line 33 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		while (TRUE) {
#line 181 "SourceInterfaces.c"
			gboolean _tmp6_ = FALSE;
			gchar** _tmp10_ = NULL;
			gint _tmp10__length1 = 0;
			gint _tmp11_ = 0;
			const gchar* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
#line 33 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
			_tmp6_ = _tmp5_;
#line 33 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
			if (!_tmp6_) {
#line 192 "SourceInterfaces.c"
				gint _tmp7_ = 0;
				gint _tmp8_ = 0;
				gchar** _tmp9_ = NULL;
				gint _tmp9__length1 = 0;
#line 39 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp7_ = ctr;
#line 39 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				ctr = _tmp7_ + 1;
#line 39 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp8_ = ctr;
#line 39 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp9_ = strs;
#line 39 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp9__length1 = strs_length1;
#line 39 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				if (!(_tmp8_ < _tmp9__length1)) {
#line 39 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
					break;
#line 211 "SourceInterfaces.c"
				}
			}
#line 33 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
			_tmp5_ = FALSE;
#line 34 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
			_tmp10_ = strs;
#line 34 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
			_tmp10__length1 = strs_length1;
#line 34 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
			_tmp11_ = ctr;
#line 34 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
			_tmp12_ = _tmp10_[_tmp11_];
#line 34 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
			_tmp13_ = is_string_empty (_tmp12_);
#line 34 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
			if (!_tmp13_) {
#line 228 "SourceInterfaces.c"
				GString* _tmp14_ = NULL;
				gchar** _tmp15_ = NULL;
				gint _tmp15__length1 = 0;
				gint _tmp16_ = 0;
				const gchar* _tmp17_ = NULL;
				gchar* _tmp18_ = NULL;
				gchar* _tmp19_ = NULL;
				gint _tmp20_ = 0;
				gchar** _tmp21_ = NULL;
				gint _tmp21__length1 = 0;
#line 35 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp14_ = builder;
#line 35 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp15_ = strs;
#line 35 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp15__length1 = strs_length1;
#line 35 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp16_ = ctr;
#line 35 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp17_ = _tmp15_[_tmp16_];
#line 35 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp18_ = g_utf8_strdown (_tmp17_, (gssize) (-1));
#line 35 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp19_ = _tmp18_;
#line 35 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				g_string_append (_tmp14_, _tmp19_);
#line 35 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_g_free0 (_tmp19_);
#line 36 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp20_ = ctr;
#line 36 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp21_ = strs;
#line 36 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				_tmp21__length1 = strs_length1;
#line 36 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
				if (_tmp20_ < (_tmp21__length1 - 1)) {
#line 265 "SourceInterfaces.c"
					GString* _tmp22_ = NULL;
#line 37 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
					_tmp22_ = builder;
#line 37 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
					g_string_append_c (_tmp22_, ' ');
#line 271 "SourceInterfaces.c"
				}
			}
		}
	}
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp24_ = builder;
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp25_ = _tmp24_->str;
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp26_ = is_string_empty (_tmp25_);
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	if (!_tmp26_) {
#line 284 "SourceInterfaces.c"
		GString* _tmp27_ = NULL;
		const gchar* _tmp28_ = NULL;
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		_tmp27_ = builder;
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		_tmp28_ = _tmp27_->str;
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		_tmp23_ = _tmp28_;
#line 293 "SourceInterfaces.c"
	} else {
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		_tmp23_ = NULL;
#line 297 "SourceInterfaces.c"
	}
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp29_ = _tmp23_;
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_tmp30_ = g_strdup (_tmp29_);
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	result = _tmp30_;
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	_g_string_free0 (builder);
#line 41 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	return result;
#line 309 "SourceInterfaces.c"
}


static void indexable_base_init (IndexableIface * iface) {
#line 18 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	static gboolean initialized = FALSE;
#line 18 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
	if (!initialized) {
#line 18 "/builddir/build/BUILD/shotwell-0.15.1/src/core/SourceInterfaces.vala"
		initialized = TRUE;
#line 320 "SourceInterfaces.c"
	}
}


GType indexable_get_type (void) {
	static volatile gsize indexable_type_id__volatile = 0;
	if (g_once_init_enter (&indexable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IndexableIface), (GBaseInitFunc) indexable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType indexable_type_id;
		indexable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Indexable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (indexable_type_id, TYPE_DATA_SOURCE);
		g_once_init_leave (&indexable_type_id__volatile, indexable_type_id);
	}
	return indexable_type_id__volatile;
}



